//
// file.h
//
// File functions
//

char Filenamepuffer[256];

void memadd(U1 *Pointer,U1 Delta,U2 Size)
{
  U2 i;
  for(i=0;i<Size;i++)
  {
    *(Pointer+i) += Delta;
  }
};

int fexist(char *Name)
{
  FILE *Handle=fopen(Name,"r");
  if(!Handle) return 0;
  fclose(Handle);
  return 1;
}

#ifndef AppDirs
char *AppDirs[]={NULL};
#endif

S1 *fsearch(S1 *Filename, S1 *Puffer)
{
  int i;
  for(i=0;AppDirs[i]!=NULL;i++)
  {
    strcpy(Puffer,AppDirs[i]);
    strcat(Puffer,Filename);
    printf("Teste: %s\n",Puffer);
    if(fexist(Puffer)) return Puffer;
  }
  return Puffer;
}

S1 Text_Low[256];

S1 *strlow(S1 *text)
{
  U2 i;
  Text_Low[0]=0;
  if(text==NULL) return (Text_Low);
  for(i=0;i<=strlen(text)&&i<255;i++)
  {
    Text_Low[i]=tolower(text[i]);
  }
  return(Text_Low);
}
S1 *floadfile(S1 *Name,S1 *Typ,long *Anzahl)
{
  FILE *Handle;
  char *Puffer;

  if (Name==NULL || Typ==NULL) return(NULL);
  Handle=fopen(Name,Typ);
  if (!Handle) return(NULL);
  fseek (Handle,0,SEEK_END);
  *Anzahl=ftell(Handle);
  Puffer=new S1[(*Anzahl)+1];
  if(Puffer==NULL) return (NULL);
  memset(Puffer,0,*Anzahl);
  fseek(Handle,0,SEEK_SET);
  fread(Puffer,1,*Anzahl,Handle);
  fclose(Handle);
  return(Puffer);
}

U1 *fload(S1 *Name,S1 *Typ,U4 &Anzahl,U1 *Puffer,U4 Head,U2 *Deskriptor=NULL)
{
  FILE *Handle;
  if (!Name) return(0);
  Handle=fopen(Name,Typ);
  if (!Handle) return(0);
  if (Anzahl==0)
  {
    fseek (Handle,0,SEEK_END);
    Anzahl=ftell(Handle)-Head;
  }
  if (Puffer==NULL)
  {
    Puffer=(U1*)malloc(Anzahl);
    if(Puffer==NULL) return 0;
  }
  fseek(Handle,Head,SEEK_SET);
  Anzahl=fread(Puffer,1,Anzahl,Handle);
  fclose(Handle);
  return(Puffer);
}

void freadt(U1 *Puffer,U4 Anzahl,FILE *Handle)
{
  U2 Character;
  while(Anzahl--)
  {
    Character=fgetc(Handle);
    if (Character==0xffff) return;
    if (Character) *Puffer=(U1)Character;
    Puffer++;
  }
}

U4 floadt(S1 *Name,S1 *Typ, U4 Anzahl,U1 *Puffer,U4 Head)
{
  FILE *Handle;
  if (!Name) return(0);
  Handle=fopen(Name,Typ);
  if (!Handle) return(0);
  if (Anzahl==0)
  {
    fseek (Handle,0,SEEK_END);
    Anzahl=ftell(Handle);
    fclose(Handle);
    return(Anzahl);
  }
  fseek(Handle,Head,SEEK_SET);
  freadt(Puffer,Anzahl,Handle);
  fclose(Handle);
  return(Anzahl);
}

int rnd(int Lower,int Upper)
{
  if (Lower< Upper) return ((rand()%(Upper-Lower+1))+Lower);
  if (Lower==Upper) return (Lower);
  if (Lower> Upper) return ((rand()%(Lower-Upper+1))+Upper);
  return 0;
}

#ifdef __linux
void delay(long n)
{
  usleep(n*1000);
}
#endif

